summaryrefslogtreecommitdiffstats
path: root/testing/source/linux-6.1.x/build-all-kernels.sh
diff options
context:
space:
mode:
author Patrick J Volkerding <volkerdi@slackware.com>2022-12-25 23:21:25 +0000
committer Eric Hameleers <alien@slackware.com>2022-12-26 01:38:31 +0100
commit5d902bcdde75d83b9fa3bed829120c2b4da690bf (patch)
tree7fadcd650df5712f2a09075203ab1713870c4f8e /testing/source/linux-6.1.x/build-all-kernels.sh
parent0f2ac1afc058e2c735395d4762dcbf69b4798ac7 (diff)
downloadcurrent-20221225232125.tar.gz
current-20221225232125.tar.xz
Sun Dec 25 23:21:25 UTC 202220221225232125
Hey folks, Merry Christmas and Hanukkah Sameach! Figured it was about time to get some kind of kernel activity going again, but it most definitely belongs in /testing for now. I've been trying to shape this up for weeks, but there are still issues, and maybe someone out there can help. The biggest problem is that the 32-bit kernels crash on boot. Initially there's some sort of Intel ME failure (this is on a Thinkpad X1E). If those modules are blacklisted, then the kernel will go on to crash loading the snd_hda_intel module. The other issue is that I've got a 4K panel in this machine, and have always appended the kernel option video=1920x1080@60 to put the console in HD instead, and then loaded a Terminus console font to make the text even larger. With these kernels, that option is completely ignored. I've tried some other syntax I've seen online to no avail. And when the Terminus font is loaded the text gets *even smaller* for some reason. So be careful of these kernels (especially the 32-bit ones), but I welcome any hints about what's going on here or if there are config changes that might get this working properly. Is anyone out there running a 6.x kernel on bare metal 32-bit x86? Cheers! ap/vim-9.0.1091-x86_64-1.txz: Upgraded. d/meson-1.0.0-x86_64-1.txz: Upgraded. d/ruby-3.2.0-x86_64-1.txz: Upgraded. Shared library .so-version bump. d/subversion-1.14.2-x86_64-3.txz: Rebuilt. Recompiled against ruby-3.2.0. l/glib2-2.74.4-x86_64-1.txz: Upgraded. l/netpbm-11.00.03-x86_64-1.txz: Upgraded. l/rubygem-asciidoctor-2.0.18-x86_64-1.txz: Upgraded. Compiled against ruby-3.2.0. n/epic5-2.1.12-x86_64-2.txz: Rebuilt. Recompiled against ruby-3.2.0. x/marisa-0.2.6-x86_64-6.txz: Rebuilt. Recompiled against ruby-3.2.0. xap/vim-gvim-9.0.1091-x86_64-1.txz: Upgraded. testing/packages/linux-6.1.x/kernel-generic-6.1.1-x86_64-1.txz: Added. testing/packages/linux-6.1.x/kernel-headers-6.1.1-x86-1.txz: Added. testing/packages/linux-6.1.x/kernel-huge-6.1.1-x86_64-1.txz: Added. testing/packages/linux-6.1.x/kernel-modules-6.1.1-x86_64-1.txz: Added. testing/packages/linux-6.1.x/kernel-source-6.1.1-noarch-1.txz: Added.
Diffstat (limited to 'testing/source/linux-6.1.x/build-all-kernels.sh')
-rwxr-xr-xtesting/source/linux-6.1.x/build-all-kernels.sh175
1 files changed, 175 insertions, 0 deletions
diff --git a/testing/source/linux-6.1.x/build-all-kernels.sh b/testing/source/linux-6.1.x/build-all-kernels.sh
new file mode 100755
index 000000000..0ac96bdf6
--- /dev/null
+++ b/testing/source/linux-6.1.x/build-all-kernels.sh
@@ -0,0 +1,175 @@
+#!/bin/sh
+
+# Copyright 2018, 2021, 2022 Patrick J. Volkerding, Sebeka, Minnesota, USA
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+# This script uses the SlackBuild scripts present here to build a
+# complete set of kernel packages for the currently running architecture.
+# It needs to be run once on 64-bit (uname -m = x86_64) and once on IA32
+# (uname -m = i586 or i686).
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+BUILD=${BUILD:-1}
+if [ -z "$VERSION" ]; then
+ # Get the filename of the newest kernel tarball:
+ KERNEL_SOURCE_FILE="$(/bin/ls -t linux-*.tar.?z | head -n 1 )"
+ if echo $KERNEL_SOURCE_FILE | grep -q rc ; then # need to get rc versions a bit differently
+ VERSION=$(/bin/ls -t linux-*.tar.?z | head -n 1 | rev | cut -f 3- -d . | cut -f 1,2 -d - | rev)
+ else # normal release version
+ VERSION=$(/bin/ls -t linux-*.tar.?z | head -n 1 | rev | cut -f 3- -d . | cut -f 1 -d - | rev)
+ fi
+fi
+TMP=${TMP:-/tmp}
+
+# By default, install the packages as we build them and update the initrd.
+INSTALL_PACKAGES=${INSTALL_PACKAGES:-YES}
+
+# Clean kernels before building them. Not doing so quit working some time
+# after 4.19.x.
+export KERNEL_CLEAN=YES
+
+# A list of recipes for build may be passed in the $RECIPES variable, otherwise
+# we have defaults based on uname -m:
+if [ -z "$RECIPES" ]; then
+ if uname -m | grep -wq x86_64 ; then
+ RECIPES="x86_64"
+ elif uname -m | grep -wq i.86 ; then
+ RECIPES="IA32_NO_SMP IA32_SMP"
+ else
+ echo "Error: no build recipes available for $(uname -m)"
+ exit 1
+ fi
+fi
+
+# Main build loop:
+for recipe in $RECIPES ; do
+
+ # Build recipes are defined here. These will select the appropriate .config
+ # files and package naming scheme, and define the output location.
+ if [ "$recipe" = "x86_64" ]; then
+ # Recipe for x86_64:
+ export CONFIG_SUFFIX=".x64"
+ unset LOCALVERSION
+ OUTPUT=${OUTPUT:-${TMP}/output-x86_64-${VERSION}}
+ elif [ "$recipe" = "IA32_SMP" ]; then
+ # Recipe for IA32_SMP:
+ unset CONFIG_SUFFIX
+ LOCALVERSION="-smp"
+ OUTPUT=${OUTPUT:-${TMP}/output-ia32-${VERSION}}
+ elif [ "$recipe" = "IA32_NO_SMP" ]; then
+ # Recipe for IA32_NO_SMP:
+ unset CONFIG_SUFFIX
+ unset LOCALVERSION
+ OUTPUT=${OUTPUT:-${TMP}/output-ia32-${VERSION}}
+ else
+ echo "Error: recipe ${recipe} not implemented"
+ exit 1
+ fi
+
+ echo
+ echo "*************************************************"
+ echo "* Building kernels for recipe ${recipe}..."
+ echo "*************************************************"
+ echo
+
+ # Build kernel-source package:
+ KERNEL_SOURCE_PACKAGE_NAME=$(PRINT_PACKAGE_NAME=YES KERNEL_CONFIG="config-generic${LOCALVERSION}-${VERSION}${LOCALVERSION}${CONFIG_SUFFIX}" VERSION=$VERSION BUILD=$BUILD ./kernel-source.SlackBuild)
+ KERNEL_CONFIG="config-generic${LOCALVERSION}-${VERSION}${LOCALVERSION}${CONFIG_SUFFIX}" VERSION=$VERSION BUILD=$BUILD ./kernel-source.SlackBuild
+ mkdir -p $OUTPUT
+ mv ${TMP}/${KERNEL_SOURCE_PACKAGE_NAME} $OUTPUT || exit 1
+ if [ "${INSTALL_PACKAGES}" = "YES" ]; then
+ installpkg ${OUTPUT}/${KERNEL_SOURCE_PACKAGE_NAME} || exit 1
+ fi
+
+ # Build kernel-huge package:
+ # We will build in the just-built kernel tree. First, let's put back the
+ # symlinks:
+ ( cd $TMP/package-kernel-source
+ sh install/doinst.sh
+ )
+ KERNEL_HUGE_PACKAGE_NAME=$(PRINT_PACKAGE_NAME=YES KERNEL_NAME=huge KERNEL_SOURCE=$TMP/package-kernel-source/usr/src/linux KERNEL_CONFIG=./kernel-configs/config-huge${LOCALVERSION}-${VERSION}${LOCALVERSION}${CONFIG_SUFFIX} CONFIG_SUFFIX=${CONFIG_SUFFIX} KERNEL_OUTPUT_DIRECTORY=$OUTPUT/kernels/huge$(echo ${LOCALVERSION} | tr -d -).s BUILD=$BUILD ./kernel-generic.SlackBuild)
+ KERNEL_NAME=huge KERNEL_SOURCE=$TMP/package-kernel-source/usr/src/linux KERNEL_CONFIG=./kernel-configs/config-huge${LOCALVERSION}-${VERSION}${LOCALVERSION}${CONFIG_SUFFIX} CONFIG_SUFFIX=${CONFIG_SUFFIX} KERNEL_OUTPUT_DIRECTORY=$OUTPUT/kernels/huge$(echo ${LOCALVERSION} | tr -d -).s BUILD=$BUILD ./kernel-generic.SlackBuild
+ if [ -r ${TMP}/${KERNEL_HUGE_PACKAGE_NAME} ]; then
+ mv ${TMP}/${KERNEL_HUGE_PACKAGE_NAME} $OUTPUT
+ else
+ echo "kernel-source build failed."
+ exit 1
+ fi
+ if [ "${INSTALL_PACKAGES}" = "YES" ]; then
+ installpkg ${OUTPUT}/${KERNEL_HUGE_PACKAGE_NAME} || exit 1
+ fi
+
+ # Build kernel-generic package:
+ KERNEL_GENERIC_PACKAGE_NAME=$(PRINT_PACKAGE_NAME=YES KERNEL_NAME=generic KERNEL_SOURCE=$TMP/package-kernel-source/usr/src/linux KERNEL_CONFIG=./kernel-configs/config-generic${LOCALVERSION}-${VERSION}${LOCALVERSION}${CONFIG_SUFFIX} CONFIG_SUFFIX=${CONFIG_SUFFIX} KERNEL_OUTPUT_DIRECTORY=$OUTPUT/kernels/generic$(echo ${LOCALVERSION} | tr -d -).s BUILD=$BUILD ./kernel-generic.SlackBuild)
+ KERNEL_NAME=generic KERNEL_SOURCE=$TMP/package-kernel-source/usr/src/linux KERNEL_CONFIG=./kernel-configs/config-generic${LOCALVERSION}-${VERSION}${LOCALVERSION}${CONFIG_SUFFIX} CONFIG_SUFFIX=${CONFIG_SUFFIX} KERNEL_OUTPUT_DIRECTORY=$OUTPUT/kernels/generic$(echo ${LOCALVERSION} | tr -d -).s BUILD=$BUILD ./kernel-generic.SlackBuild
+ if [ -r ${TMP}/${KERNEL_GENERIC_PACKAGE_NAME} ]; then
+ mv ${TMP}/${KERNEL_GENERIC_PACKAGE_NAME} $OUTPUT
+ else
+ echo "kernel-generic build failed."
+ exit 1
+ fi
+ if [ "${INSTALL_PACKAGES}" = "YES" ]; then
+ installpkg ${OUTPUT}/${KERNEL_GENERIC_PACKAGE_NAME} || exit 1
+ fi
+
+ # Build kernel-modules (for the just built generic kernel, but most of them
+ # will also work with the huge kernel):
+ KERNEL_MODULES_PACKAGE_NAME=$(PRINT_PACKAGE_NAME=YES KERNEL_SOURCE=$TMP/package-kernel-source/usr/src/linux KERNEL_CONFIG=$TMP/package-kernel-source/usr/src/linux/.config BUILD=$BUILD ./kernel-modules.SlackBuild)
+ KERNEL_SOURCE=$TMP/package-kernel-source/usr/src/linux KERNEL_CONFIG=$TMP/package-kernel-source/usr/src/linux/.config BUILD=$BUILD ./kernel-modules.SlackBuild
+ if [ -r ${TMP}/${KERNEL_MODULES_PACKAGE_NAME} ]; then
+ mv ${TMP}/${KERNEL_MODULES_PACKAGE_NAME} $OUTPUT
+ else
+ echo "kernel-modules build failed."
+ exit 1
+ fi
+ if [ "${INSTALL_PACKAGES}" = "YES" ]; then
+ installpkg ${OUTPUT}/${KERNEL_MODULES_PACKAGE_NAME} || exit 1
+ fi
+
+ # Build kernel-headers:
+ KERNEL_HEADERS_PACKAGE_NAME=$(PRINT_PACKAGE_NAME=YES KERNEL_SOURCE=$TMP/package-kernel-source/usr/src/linux BUILD=$BUILD ./kernel-headers.SlackBuild)
+ KERNEL_SOURCE=$TMP/package-kernel-source/usr/src/linux BUILD=$BUILD ./kernel-headers.SlackBuild
+ if [ -r ${TMP}/${KERNEL_HEADERS_PACKAGE_NAME} ]; then
+ mv ${TMP}/${KERNEL_HEADERS_PACKAGE_NAME} $OUTPUT
+ else
+ echo "kernel-headers build failed."
+ exit 1
+ fi
+ if [ "${INSTALL_PACKAGES}" = "YES" ]; then
+ upgradepkg --reinstall --install-new ${OUTPUT}/${KERNEL_HEADERS_PACKAGE_NAME} || exit 1
+ fi
+
+ # Update initrd:
+ if [ "${INSTALL_PACKAGES}" = "YES" ]; then
+ INITRD_VERSION="$(grep "Kernel Configuration" $TMP/package-kernel-source/usr/src/linux/.config | cut -f 3 -d ' ')"
+ INITRD_LOCALVERSION="$(cat $TMP/package-kernel-source/usr/src/linux/.config 2> /dev/null | grep CONFIG_LOCALVERSION= | cut -f 2 -d = | tr -d \")"
+ if [ -r /etc/mkinitrd.conf ]; then
+ mkinitrd -F /etc/mkinitrd.conf -k ${INITRD_VERSION}${INITRD_LOCALVERSION}
+ else # try this?
+ sh /usr/share/mkinitrd/mkinitrd_command_generator.sh -k ${INITRD_VERSION}${INITRD_LOCALVERSION} | sed "s/-c -k/-k/g" | bash
+ fi
+ fi
+
+ echo
+ echo "${recipe} kernel packages done!"
+ echo
+
+done